' Bestimme Weite und Hhe eines Textes.

' Eine Beschreibung dieser Prozedur befindet sich im Testprogramm QTxtWeit.prf
' Version 2.5  14.1.2010.      Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka
'                       email: gerhard-putschalka@gmx.at
'                    homepage: http://www.gerhard-putschalka.xprofan.com/index.htm

' Weite eines Textes bestimmen. Par.1 = Text$ (Stringvariable),
'                               Par.2 = 0 oder 1. 0 = fr Bildschirmausgabe
'                                                 1 = fr die Ausgabe an den Drucker.
' Fr die Ausgabe zum Drucker wird die Lnge durch 10 dividiert.

' der zu prfende Text mu in der Stringvariablen (Parameter 1) stehen.
' Rckgabe: Weite des Textes in Q_Text&[0] und auch in @&(0)
'           Hhe  des Textes in Q_Text&[1]

Def @GetWeite(4) ! "GDI32","GetTextExtentPoint32A"

Declare Q_Text&[2]  ' das Array ist global definiert!

Proc TextWeite
  Parameters T$,Prt_Ctl%
  Declare Z$,Adr&,Adr1&,Leng&  '
  Adr&  = @Addr(T$)       ' Adresse der Stringvariablen
  Z$    = "00000000"      ' ersetzt eine Bereichsvariable fr 2 LongInteger
  Adr1& = @Addr(Z$)       ' Adresse der ~Bereichsvariablen
  ' korrigiere die Adressen zum Datenanfang wenn Profanversion < 7
  Case (@Left$($ProfVer,1) < "7") : Adr& = (Adr& + 1)
  Case (@Left$($ProfVer,1) < "7") : Adr1& = (Adr1& + 1)   
  @GetWeite(%HDC,Adr&,@Len(T$),Adr1&)

  Q_Text&[0] = @Long(Adr1&,0)   ' Weite des Textes in Pixel
  Q_Text&[1] = @Long(Adr1&,4)   ' Hhe des Textes in Pixel

  If (Prt_Ctl% = 1)
    Q_Text&[0] = (Q_Text&[0] / 10)
    Q_Text&[1] = (Q_Text&[1] / 10)
  EndIf
  Return Q_Text&[0]  ' fr Kompatibilitt zu Versionen < 2.4
EndProc
